echo off
set GDCC_PATH=%CD%\..\gdcc
set PATH=%GDCC_PATH%;%PATH%
title Building HDoom Source
cls

if not exist acs (
	mkdir acs
)

if not exist ir (
	mkdir ir
)

if not exist acs\libc.bin (
	echo Building libc . . . 
	gdcc-makelib --target-engine=ZDoom libc -c -o ir/libc.ir
	gdcc-makelib --target-engine=ZDoom libGDCC -c -o ir/libGDCC.ir
	gdcc-ld --target-engine=ZDoom --bc-zdacs-init-delay --alloc-min Sta "" 1000000000 ir/libc.ir ir/libGDCC.ir -o acs/libc.bin
)

echo Building C code . . . 
gdcc-cc --target-engine=ZDoom -c source/*.c --sys-include source -o ir/hdoom.ir
gdcc-ld --target-engine=ZDoom --bc-zdacs-init-delay -llibc ir/hdoom.ir -o acs/hdoom.bin

echo Compiling ACS scripts . . . 
gdcc-acc -lhdoom scripts/main.acs -o acs/hscripts.bin

echo Compiling VNS scripts . . . 
for %%f in (vns/*.vns) do (
	vnsc "vns/%%f"
)

echo Done.
echo Press any key to exit . . . 
pause >nul
